#<profile4xi profile = "11"/>
# -----------------------------------------------------------------------------------------------
#<program4xi program = "test_managers4xi.py">
#<abstract4xi abstract = "tests managers4xi"/>
#<verify4xi verification = "10" target = "manager4xi.py"/>
#<contextualize4xi context = "process4xi.py; queue4xi.py; pipe4xi.py; lock4xi.py; pool4xi.py; manager4xi.py; server4xi.py; server4xi.py; basemanager4xi.py; processlocalset4xi.py; forkingpickler4xi.py; remoteerror4xi.py;  baseproxy4xi.py; rebuildproxy4xi.py; namespace4xi.py; value4xi.py; iteratorproxy4xi.py; acquirerproxy4xi.py; conditionproxy4xi.py; eventproxy4xi.py; namespaceproxy4xi.py; valueproxy4xi.py; listproxy4xi.py; syncmanager4xi.py; reduce_array4xi.py; rebuild_as_list4xi.py; dispatch4xi.py; convert_to_error4xi.py; all_methods4xi.py; public_methods4xi.py; listener_client4xi.py; arrayfunction4xi.py; makeproxytype4xi.py; autoproxy4xi.py; baselistproxy4xi.py; dictproxy4xi.py; arrayproxy4xi.py; poolproxy4xi.py"/>
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting; [Rel 7.21]"/>
# -------------------------------------------------------------------------------------------------

# -------------------------------------------------------------------------------------------------
# Public API
# -------------------------------------------------------------------------------------------------
#<interface4xi interface = " 
__all__ = [ 'test_managers4xi' ]
#"
#/>

# -------------------------------------------------------------------------------------------------
#                               
# -------------------------------------------------------------------------------------------------
__all__ = [ 'BaseManager', 'SyncManager', 'BaseProxy', 'Token','BaseManagerXi2', 'SyncManagerXi2', 'BaseProxyXi2', 'TokenXi2' ]


# -------------------------------------------------------------------------------------------------
# Standard Imports                          
# -------------------------------------------------------------------------------------------------
#<standardize4xi standard = "
import os
import sys
import weakref
import threading
import array
import queue
from traceback import format_exc
import _winapi
#"
#/>

# -------------------------------------------------------------------------------------------------
# Multiprocessing Imports                          
# -------------------------------------------------------------------------------------------------
#<process4xi process = "


# -------------------------------------------------------------------------------------------------
# multiprocessing package imports                              
# -------------------------------------------------------------------------------------------------
from multiprocessing import Process, current_process, active_children, Pool, util, connection
from multiprocessing.process import AuthenticationString
from multiprocessing.forking import Popen, assert_spawning, ForkingPickler
from multiprocessing.util import Finalize, info

# -------------------------------------------------------------------------------------------------
# conditional imports                              
# -------------------------------------------------------------------------------------------------
try:
    from cPickle import PicklingError
except ImportError:
    from pickle import PicklingError

#"
#/>

# -------------------------------------------------------------------------------------------------
# DragonXi imports                              
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "
from process4xi import Process4Xi
from queue4xi import Queue4Xi
from pipe4xi import Pipe4Xi
from lock4xi import Lock4Xi
from pool4xi import Pool4Xi
from manager4xi import Manager4Xi     
from server4xi import Server4Xi
from basemanager4xi import BaseManager4Xi
from processlocalset4xi import ProcessLocalSet4Xi
from forkingpickler4xi import ForkingPickler4Xi
from remoteerror4xi import RemoteError4Xi
from baseproxy4xi import BaseProxy4Xi
from rebuildproxy4xi import RebuildProxy4Xi
from namespace4xi import Namespace4Xi
from value4xi import Value4Xi
from iteratorproxy4xi import IteratorProxy4Xi
from acquirerproxy4xi import AcquirerProxy4Xi
from conditionproxy4xi import ConditionProxy4Xi
from eventproxy4xi import EventProxy4Xi
from namespaceproxy4xi import NamespaceProxy4Xi
from valueproxy4xi import ValueProxy4Xi
from listproxy4xi import ListProxy4Xi
from syncmanager4xi import SyncManager4Xi


from reduce_array4xi import reduce_array4xi    
from rebuild_as_list4xi import rebuild_as_list4xi
from dispatch4xi import dispatch4xi
from convert_to_error4xi import convert_to_error4xi
from all_methods4xi import all_methods4xi
from public_methods4xi import public_methods4xi
from listener_client4xi import listener_client4xi
from arrayfunction4xi import ArrayFunction4Xi
from makeproxytype4xi import MakeProxyType4Xi
from autoproxy4xi import AutoProxy4Xi


from baselistproxy4xi import BaseListProxy4Xi
from dictproxy4xi import DictProxy4Xi
from arrayproxy4xi import ArrayProxy4Xi
from poolproxy4xi import PoolProxy4Xi
from print4xi import Print4Xi
from pickle4xi import pickle4xi
from pickle2a4xi import Pickle2a4Xi
from pickle2b4xi import Pickle2b4Xi
from pickle2c4xi import Pickle2c4Xi
from pickle2d4xi import Pickle2d4Xi
from pickle2e4xi import Pickle2e4Xi
from pickle2f4xi import Pickle2f4Xi
from pickle2g4xi import Pickle2g4Xi
from pickle2h4xi import Pickle2h4Xi
from pickle2i4xi import Pickle2i4Xi
from pickle2j4xi import Pickle2j4Xi
from pickle2k4xi import Pickle2k4Xi
from pickle2l4xi import Pickle2l4Xi
from pickle2m4xi import Pickle2m4Xi
from pickle2n4xi import Pickle2n4Xi
from pickle2o4xi import Pickle2o4Xi
from pickle2p4xi import Pickle2p4Xi
from pickle2q4xi import Pickle2q4Xi
from pickle2r4xi import Pickle2r4Xi
from pickle2s4xi import Pickle2s4Xi
from pickle2t4xi import Pickle2t4Xi
from pickle2u4xi import Pickle2u4Xi
from pickle2v4xi import Pickle2v4Xi
from pickle2w4xi import Pickle2w4Xi
from pickle2x4xi import Pickle2x4Xi
from pickle2y4xi import Pickle2y4Xi
from pickle2z4xi import Pickle2z4Xi
from pickle2_4xi import Pickle2_4Xi      

from time4xi import time4xi

from xml_trace_sense4xi import xml_trace_sense4xi
from xml_trace_reason4xi import xml_trace_reason4xi
from xml_trace_ace4xi import xml_trace_ace4xi 
#" 
#/>
# -------------------------------------------------------------------------------------------------
# Global constants                            
# ------------------------------------------------------------------------------------------------
#<globalize4xi globalization = "
global t2xi 
global trace_object_count
global PickleKB4Xi

# -------------------------------------------------------------------------------------------------
# Settings
# -------------------------------------------------------------------------------------------------
#<set4xi setting = "
PickleKB4Xi = {
       'a': Pickle2a4Xi,
       'b': Pickle2b4Xi,
       'c': Pickle2c4Xi,
       'd': Pickle2d4Xi,
       'e': Pickle2e4Xi,
       'f': Pickle2f4Xi,
       'g': Pickle2g4Xi,
       'h': Pickle2h4Xi,
       'i': Pickle2i4Xi,
       'j': Pickle2j4Xi,
       'k': Pickle2k4Xi,
       'l': Pickle2l4Xi,
       'm': Pickle2m4Xi,
       'n': Pickle2n4Xi,
       'o': Pickle2o4Xi,
       'p': Pickle2p4Xi,
       'q': Pickle2q4Xi,
       'r': Pickle2r4Xi,
       's': Pickle2s4Xi,
       't': Pickle2t4Xi,
       'u': Pickle2u4Xi,
       'v': Pickle2v4Xi,
       'w': Pickle2w4Xi,
       'x': Pickle2x4Xi,
       'y': Pickle2y4Xi,
       'z': Pickle2z4Xi,
       '_': Pickle2_4Xi} 
#"
#"/>

# ----------------------------------------------------------------------------------------------------------
#<function4xi function = "set2trace4xi" usage = "setting trace using definitions in pickle4xi functions !
#">                      
# ----------------------------------------------------------------------------------------------------------    
def set2trace4xi():
    global t2xi 
    global trace_object_count
    global PickleKB4Xi

    # print("(Step 0A/33) OF SET2TRACE4XI - STARTING SETTING TRACE BASED ON TRACE SETTINGS IN MODULES PICKLE2x4XI.PY (x=a,b...) ", time4xi()) 
    # print("(Step 0B/33) OF SET2TRACE4XI - USING T2XI: ", t2xi)
    # <print4xi.Print4Xi object at 0x0000000003715080>    
    
    # ---------------------------------------------------------------------------------------------
    # A, B .... _ 
    # ---------------------------------------------------------------------------------------------
    keys2pickledb = sorted(PickleKB4Xi.keys())
    for key2pickledb in keys2pickledb:
        # -----------------------------------------------------------------------------------------    
        # LETTERS
        # -----------------------------------------------------------------------------------------     
        # print('=' *33)
        # print("STARTING LETTER : ", key2pickledb)
        # print('=' *33)
   
        dictionary2pickle = PickleKB4Xi[key2pickledb]        
        # print("STARTING DICTIONARY: ", dictionary2pickle)
        # print('~' *33) 
        # 
        keys2dictionary = sorted(dictionary2pickle.keys())
    
        # -----------------------------------------------------------------------------------------    
        #
        # -----------------------------------------------------------------------------------------     
        for key2dictionary in keys2dictionary:
            # -------------------------------------------------------------------------------------    
            # DICTIONARY
            # -------------------------------------------------------------------------------------     
            # print('~' *33)        
            object2pickle = key2dictionary        
            # print("STARTING OBJECT: ", object2pickle)
            # print('~' *33)         
            # pickle4xi(object2pickle)
            # print('~' *33)                  
            # print("PICKLED object: ", object2pickle)
            # PICKLED object:  _C4Xi, 
            # ---------------------------------------------------------------------------------    
            # Mark those with NACK4XI to be traced !
            # ---------------------------------------------------------------------------------     
            if dictionary2pickle[key2dictionary] == 'NACK4XI':
                set_param2xi = True     
                key_param = object2pickle     
                t2xi.set_print_permission(key_param, set_param2xi)
                # print("(Step 2A/33) OF SET2TRACE4XI - MARKED TO BE TRACED OBJECT: ", object2pickle)                                
                # 
            else:
                pass  
            # ---------------------------------------------------------------------------------    
            # END OF DICTIONARY
            # ---------------------------------------------------------------------------------     
        # -----------------------------------------------------------------------------------------    
        # END OF LETTERS
        # -----------------------------------------------------------------------------------------     
        # print('~' *33)        
        # print("COMPLETED  DICTIONARY: ", dictionary2pickle)
        # print('~' *33) 
    # -----------------------------------------------------------------------------------------    
    #
    # -----------------------------------------------------------------------------------------     
    # print('=' *33)
    # print("COMPLETED LETTER : ", key2pickledb)
    # print('=' *33)
    # ---------------------------------------------------------------------------------------------
    # 
    # ---------------------------------------------------------------------------------------------
    print('=' *33)
    print("(Step 33/33) OF SET2TRACE4XI - COMPLETED SETTING TRACE BASED ON NACK4XI/ACK4XI SETTINGS IN MODULES PICKLE2x4XI.PY (x=a,b...) ", time4xi()) 
    print('=' *33)
#</function4xi> 

       
# -------------------------------------------------------------------------------------------------
#<function4xi function = "deny2trace4xi" usage = "
#   deny trace using pickle4xi functions !
#">                      
# -------------------------------------------------------------------------------------------------    
def deny2trace4xi():
    global t2xi 
    global trace_object_count
    global PickleKB4Xi

    print("(Step 01A/33) of DENY2TRACE4XI: STARTING DENYING TRACE IN MODULES PICKLE2x4XI.PY (x=a,b...) ", time4xi()) 
    print("(Step 01B/33) OF DENY2TRACE4XI - USING T2XI: ", t2xi)
    # <print4xi.Print4Xi object at 0x0000000003715080>
    
    # ---------------------------------------------------------------------------------------------
    # A, B .... _ 
    # ---------------------------------------------------------------------------------------------
    keys2pickledb = sorted(PickleKB4Xi.keys())
    for key2pickledb in keys2pickledb:
        # -----------------------------------------------------------------------------------------    
        # LETTERS
        # -----------------------------------------------------------------------------------------     
        # print("(Step 02A/33) OF DENY2TRACE4XI - STARTING LETTER : ", key2pickledb)
        dictionary2pickle = PickleKB4Xi[key2pickledb]        
        # print("(Step 02B/33) OF DENY2TRACE4XI - STARTING DICTIONARY: ", dictionary2pickle)
        keys2dictionary = sorted(dictionary2pickle.keys())
        # -----------------------------------------------------------------------------------------    
        #
        # -----------------------------------------------------------------------------------------     
        for key2dictionary in keys2dictionary:
   
            # -------------------------------------------------------------------------------------    
            # DICTIONARY
   
            object2pickle = key2dictionary        
            # print("(Step 02C/33) OF DENY2TRACE4XI - STARTING OBJECT: ", object2pickle)
            # pickle4xi(object2pickle)        
            # print("STEP: PICKLED object: ", object2pickle)
            # PICKLED object:  _C4Xi, 
            
            # ---------------------------------------------------------------------------------    
            # ACK4XI = tested .i.e. NOT to be traced! 
            # ---------------------------------------------------------------------------------     
            set_param2xi = 'ACK4XI'     
            key_param = object2pickle     
            t2xi.set_print_permission(key_param, set_param2xi)
            # print("(Step 02D/33) OF DENY2TRACE4XI - MARKED TESTED AND NOT to be traced: ", object2pickle)
            
            dictionary2pickle[key2dictionary] = 'ACK4XI' 
                    
        
            # ---------------------------------------------------------------------------------    
            # END OF DICTIONARY
            # ---------------------------------------------------------------------------------     
            # print('~' *33)              
            # print("(Step 02Z/33) OF DENY2TRACE4XI *** FAILED - ERROR IN PICKLING OBJECT - NOT TO BE TRACED: ", object2pickle)
            # print('~' *33) 
        # -----------------------------------------------------------------------------------------    
        # END OF LETTERS
        # -----------------------------------------------------------------------------------------     
        # print("(Step 02E/33) OF DENY2TRACE4XI - COMPLETED  DICTIONARY: ", dictionary2pickle)
        # 
        
    # -----------------------------------------------------------------------------------------    
    #
    # -----------------------------------------------------------------------------------------     
    # print("(Step 02F/33) OF DENY2TRACE4XI - COMPLETED LETTER : ", key2pickledb)
    # _, a ... z            
    print("(Step 033/33) OF SET2TRACE4XI - COMPLETED DENYING TRACE IN MODULES PICKLE2x4XI.PY (x=a,b...) ", time4xi()) 
#</function4xi> 

# -------------------------------------------------------------------------------------------------
#<function4xi function = "tailor2trace4xi" usage = "
#   tailors trace 
#">                      
# -------------------------------------------------------------------------------------------------    
def tailor2trace4xi():
    global trace_object_count
    global PickleKB4Xi 
    global t2xi
 
    print("(Step 001A/33) OF TAILOR2TRACE4XI - USING T2XI: ", t2xi)
    # <print4xi.Print4Xi object at 0x0000000003715080> 
                         
    # ---------------------------------------------------------------------------------------------
    # Settings to tailor trace
    # ---------------------------------------------------------------------------------------------
    #<set4xi setting = "
    KB4Tailoring = {
        'Process4Xi': 'NACK4TRACE',
        'Queue4Xi': 'NACK4TRACE',
        'Pipe4Xi': 'NACK4TRACE',
        'Lock4Xi': 'NACK4TRACE',
        'Pool4Xi': 'NACK4TRACE',
        'Manager4Xi': 'NACK4TRACE',
        'Server4Xi': 'NACK4TRACE',
        'BaseManager4Xi': 'NACK4TRACE',
        'ProcessLocalSet4Xi': 'NACK4TRACE',
        'ForkingPickler4Xi': 'NACK4TRACE',
        'BaseProxy4Xi': 'NACK4TRACE',
        'RebuildProxy4Xi': 'NACK4TRACE',
        'Namespace4Xi': 'NACK4TRACE',
        'Value4Xi': 'NACK4TRACE',
        'IteratorProxy4Xi': 'NACK4TRACE',
        'AcquirerProxy4Xi': 'NACK4TRACE',
        'ConditionProxy4Xi': 'NACK4TRACE',
        'EventProxy4Xi': 'NACK4TRACE',
        'NamespaceProxy4Xi': 'NACK4TRACE',
        'ValueProxy4Xi': 'NACK4TRACE',
        'ListProxy4Xi': 'NACK4TRACE',
        'SyncManager4Xi': 'NACK4TRACE',
        'ArrayFunction4Xi': 'NACK4TRACE',
        'AutoProxy4Xi': 'NACK4TRACE',
        'BaseListProxy4Xi': 'NACK4TRACE',
        'DictProxy4Xi': 'NACK4TRACE',
        'ArrayProxy4Xi': 'NACK4TRACE',
        'PoolProxy4Xi': 'NACK4TRACE'
        }                             
                
    default3trace = 'NACK4TRACE' # we do NOT want trace if object is not found! 
    #"/>
    
    # ---------------------------------------------------------------------------------------------
    # PROCESS KB4Tailoring
    # ---------------------------------------------------------------------------------------------
    keys2tailor = sorted(KB4Tailoring.keys())
    for key2tailor in keys2tailor:
        # ---------------------------------------------------------------------------------    
        # NACK4XI = NOT TESTED .I.E. TO BE TRACED! 
        # ---------------------------------------------------------------------------------     
        set_param2xi = 'NACK4XI'     
        key_param = key2tailor    
        t2xi.set_print_permission(key_param, set_param2xi)
        print("(Step 002A/33) OF TAILOR_TRACE4XI - MARKED TO BE TESTED: ", key2tailor)
        # 
        
    # -----------------------------------------------------------------------------------------    
    # EOF KEYS
    # -----------------------------------------------------------------------------------------     
    print("(Step 0033/33) OF TAILOR_TRACE4XI - COMPLETED  TAILORING: ", time4xi())
    #

    
#</function4xi>       


# -------------------------------------------------------------------------------------------------   
ForkingPickler4Xi.register(array.array, reduce_array4xi) #<--- ok
#
#
view_types = [type(getattr({}, name)()) for name in ('items','keys','values')]

if view_types[0] is not list:       # only needed in Py3.0

    for view_type in view_types:
        ForkingPickler4Xi.register(view_type, rebuild_as_list4xi) #<--- ok
        import copyreg
        copyreg.pickle(view_type, rebuild_as_list4xi)
        
        
# -------------------------------------------------------------------------------------------------   
# removed from this module and imported from dragonized modules
# -------------------------------------------------------------------------------------------------   
# Token class
# dispatch function
# convert_to_error                        
# RemoteError class                         
# all_methods function
# public_methods function                           
# class Server class
# class State setting
# listener_client function 
# BaseManager class
# ProcessLocalSet class
# BaseProxy class
# RebuildProxy class
# MakeProxyType function
# AutoProxy function                              
# Value class                              
# Array function                              
# IteratorProxy class                              
# AcquirerProxy class                              
# ConditionProxy class                              
# EventProxy class                              
# NamespaceProxy class                             
# ValueProxy class                              
# BaseListProxy type                              
# ListProxy class                              
# DictProxy type                              
# ArrayProxy type                              
# PoolProxy type                              
# SyncManager class                              

# -------------------------------------------------------------------------------------------------
# code of managers.py    
# -------------------------------------------------------------------------------------------------
# SyncManager4Xi.register('Queue', queue.Queue)
# SyncManager4Xi.register('JoinableQueue', queue.Queue)
# SyncManager4Xi.register('Event', threading.Event, EventProxy)
# SyncManager4Xi.register('Lock', threading.Lock, AcquirerProxy)
# SyncManager4Xi.register('RLock', threading.RLock, AcquirerProxy)
# SyncManager4Xi.register('Semaphore', threading.Semaphore, AcquirerProxy)
# SyncManager4Xi.register('BoundedSemaphore', threading.BoundedSemaphore, AcquirerProxy)
# SyncManager4Xi.register('Condition', threading.Condition, ConditionProxy)
# SyncManager4Xi.register('Pool', Pool, PoolProxy)
# SyncManager4Xi.register('list', list, ListProxy)
# SyncManager4Xi.register('dict', dict, DictProxy)
# SyncManager4Xi.register('Value', Value, ValueProxy)
# SyncManager4Xi.register('Array', Array, ArrayProxy)
# SyncManager4Xi.register('Namespace', Namespace, NamespaceProxy)
# types returned by methods of PoolProxy
# SyncManager.register('Iterator', proxytype=IteratorProxy, create_method=False)
# SyncManager.register('AsyncResult', create_method=False)

# -------------------------------------------------------------------------------------------------
# code of this module    
# -------------------------------------------------------------------------------------------------
SyncManager4Xi.register('Queue4Xi', Queue4Xi)
SyncManager4Xi.register('JoinableQueue4Xi', Queue4Xi)
SyncManager4Xi.register('Event4Xi', threading.Event, EventProxy4Xi)
SyncManager4Xi.register('Lock4Xi', threading.Lock, AcquirerProxy4Xi)
SyncManager4Xi.register('RLock4Xi', threading.RLock, AcquirerProxy4Xi)
SyncManager4Xi.register('Semaphore4Xi', threading.Semaphore, AcquirerProxy4Xi)
SyncManager4Xi.register('BoundedSemaphore4Xi', threading.BoundedSemaphore, AcquirerProxy4Xi)
SyncManager4Xi.register('Condition4Xi', threading.Condition, ConditionProxy4Xi)
SyncManager4Xi.register('Pool4Xi', Pool4Xi, PoolProxy4Xi)
SyncManager4Xi.register('list', list, ListProxy4Xi)
SyncManager4Xi.register('dict', dict, DictProxy4Xi)
SyncManager4Xi.register('Value4Xi', Value4Xi, ValueProxy4Xi)
SyncManager4Xi.register('ArrayFunction4Xi', ArrayFunction4Xi, ArrayProxy4Xi)
SyncManager4Xi.register('Namespace4Xi', Namespace4Xi, NamespaceProxy4Xi)
# types returned by methods of PoolProxy
SyncManager4Xi.register('Iterator4Xi', proxytype=IteratorProxy4Xi, create_method=False)
SyncManager4Xi.register('AsyncResult4Xi', create_method=False)

# -------------------------------------------------------------------------------------------------
# test                              
# -------------------------------------------------------------------------------------------------
def test():
    print("\n =================================")
    print("\n test_managers4xi.py: tests dragonized managers.py")
    print("\n =================================")

# -------------------------------------------------------------------------------------------------
# main function                              
# -------------------------------------------------------------------------------------------------
def main():

    test()
    

         

# -------------------------------------------------------------------------------------------------
#                               
# -------------------------------------------------------------------------------------------------
if __name__ == '__main__':
    main()          
    
#</program4xi>
# -------------------------------------------------------------------------------------------------
# Recorded History                             
# ------------------------------------------------------------------------------------------------- 
#<record4xi record = "
#   test_managers4xi.txt

#"
#>


# -------------------------------------------------------------------------------------------------
# Legal Notice                             
# ------------------------------------------------------------------------------------------------- 
#<protect4xi protection = "copyright"
#   owner = "Small & Smart"
#   rights = "All rights reserved"
#   state = "California"
#   country = "United States of America"
#   references = "Legal notice at www.dragonxi.com; www.yourdragonxi.com; www.yourdragonxi.org; www.dragon2xi.com/; www.dragon4xi.com/; www.dragon8xi.com/ " 
#   codes = "Codes established in California and applicable to corporations in California"
#   compliance = "The California Law"
#   court = "Supreme Court of California, 350 McAllister Street, San Francisco, CA 94102-4783"
#/>
     
#<end4xi end = "
# -------------------------------------------------------------------------------------------------
# end of test_managers4xi.py                             
# ------------------------------------------------------------------------------------------------- 
#"
#/>



